#include "ai.h"
#define USING_MOV_D     1
#define GENMOV_W_MASK   15
#define _MACRO_CREATE_MOVING(arg_action_name,arg_wkspin) \
    Moving nm = m; \
    nm.x = nx; \
    nm.y = ny; \
    nm.spin = ns; \
    nm.movs.push_back(Moving::##arg_action_name##); \
    nm.wallkick_spin = arg_wkspin
#define _MACRO_HASH_POS(arg_hash_table,arg_prefix) \
    arg_hash_table[##arg_prefix##y][##arg_prefix##s][##arg_prefix##x & GENMOV_W_MASK]

namespace AI {
    std::vector<int> g_combo_attack;
    bool g_spin180 = false;

    void setComboList( std::vector<int> combolist ) {
        g_combo_attack = combolist;
    }
    int getComboAttack( int combo ) {
        if ( g_combo_attack.empty() ) return 0;
        if ( combo >= (int)g_combo_attack.size() ) return g_combo_attack.back();
        return g_combo_attack[combo];
    }
    void setSpin180( bool enable ) {
        g_spin180 = enable;
    }
    bool spin180Enable() {
        return g_spin180;
    }

    void GenMoving(const GameField& field, std::vector<Moving> & movs, Gem cur, int x, int y, bool hold) {
        movs.clear();
        if ( field.isCollide(x, y, getGem(cur.num, cur.spin) ) ) {
            return ;
        }
        char _hash[64][4][GENMOV_W_MASK+1] = {0};
        char _hash_drop[64][4][GENMOV_W_MASK+1] = {0};
        char (*hash)[4][GENMOV_W_MASK+1] = &_hash[gem_add_y];
        char (*hash_drop)[4][GENMOV_W_MASK+1] = &_hash_drop[gem_add_y];
        MovList<Moving> q(1024);
        {
            Moving m;
            m.x = x;
            m.y = y;
            m.spin = cur.spin;
            m.wallkick_spin = 0;
            if ( hold ) {
                m.movs.push_back(Moving::MOV_HOLD);
            } else {
                m.movs.push_back(Moving::MOV_NULL);
            }
            m.score = 0;
            q.push(m);
            hash[m.y][m.spin][m.x & GENMOV_W_MASK] = 1;
        }
        while ( ! q.empty() ) {
            Moving m;
            q.pop(m);
            if ( m.y < -1 ) continue;
            if ( m.movs.back() == Moving::MOV_DROP) {
                if ( cur.num == GEMTYPE_T && m.wallkick_spin != 2 ) {
                    if ( hash_drop[m.y][m.spin][m.x & GENMOV_W_MASK] == 1 ) {
                        movs.push_back(m);
                    }
                } else {
                    movs.push_back(m);
                }
                continue;
            }

            if ( m.movs.back() != Moving::MOV_DD && m.movs.back() != Moving::MOV_D)
            {
                int nx = m.x, ny = m.y, ns = m.spin;
                int wallkick_spin = m.wallkick_spin;
                while ( field.row[ny + cur.geth()] == 0 && ny + cur.geth() <= field.height() ) { // ǿвʹõŻ
                    ++ny; wallkick_spin = 0;
                }
                while ( ! field.isCollide(nx, ny + 1, getGem(cur.num, ns) ) ) {
                    if ( !USING_MOV_D && _MACRO_HASH_POS(hash, n) == 0) {
                        _MACRO_HASH_POS(hash, n) = 1;
                    }
                    ++ny; wallkick_spin = 0;
                }
                {
                    if ( _MACRO_HASH_POS(hash_drop, n) == 0 ||
                        cur.num == GEMTYPE_T &&
                        _MACRO_HASH_POS(hash_drop, n) != 2 && wallkick_spin == 2
                        )
                    {
                        int _nx = nx, _ny = ny, _ns = ns;
                        if ( cur.num == GEMTYPE_I || cur.num == GEMTYPE_Z || cur.num == GEMTYPE_S ) {
                            if ( ns == 2 ) {
                                _ny = ny + 1;
                                _ns = 0;
                            }
                            if ( ns == 3 ) {
                                _nx = nx + 1;
                                _ns = 1;
                            }
                        }
                        if ( _MACRO_HASH_POS(hash_drop, _n) == 0 ||
                            cur.num == GEMTYPE_T &&
                            _MACRO_HASH_POS(hash_drop, _n) != 2 && wallkick_spin == 2
                            ) {
                            _MACRO_CREATE_MOVING(MOV_DROP, wallkick_spin);
                            ++_MACRO_HASH_POS(hash_drop, _n);
                            q.push(nm);
                        }
                    }
                    if ( ny != y ) {
                        if ( _MACRO_HASH_POS(hash, n) == 0) {
                            _MACRO_CREATE_MOVING(MOV_DD, 0);
                            _MACRO_HASH_POS(hash, n) = 1;
                            q.push(nm);
                        }
                    }
                }
            }
            {
                int nx = m.x, ny = m.y, ns = m.spin;
                --nx;
                if ( _MACRO_HASH_POS(hash, n) == 0) {
                    if ( ! field.isCollide(nx, ny, getGem(cur.num, ns) ) ) {
                        _MACRO_CREATE_MOVING(MOV_L, 0);
                        _MACRO_HASH_POS(hash, n) = 1;
                        q.push(nm);
                    }
                }
            }
            {
                int nx = m.x, ny = m.y, ns = m.spin;
                ++nx;
                if ( _MACRO_HASH_POS(hash, n) == 0) {
                    if ( ! field.isCollide(nx, ny, getGem(cur.num, ns) ) ) {
                        _MACRO_CREATE_MOVING(MOV_R, 0);
                        _MACRO_HASH_POS(hash, n) = 1;
                        q.push(nm);
                    }
                }
            }
            if (USING_MOV_D)
            if ( m.movs.back() != Moving::MOV_DD )
            {
                int nx = m.x, ny = m.y, ns = m.spin;
                ++ny;
                Moving nm = m;
                while ( field.row[ny + cur.geth()] == 0 && ny + cur.geth() <= field.height() ) { // ǿвʹõŻ
                    ++ny;
                    nm.movs.push_back(Moving::MOV_D);
                }
                if ( _MACRO_HASH_POS(hash, n) == 0) {
                    if ( ! field.isCollide(nx, ny, getGem(cur.num, ns) ) ) {
                        _MACRO_CREATE_MOVING(MOV_D, 0);
                        _MACRO_HASH_POS(hash, n) = 1;
                        q.push(nm);
                    }
                }
            }
            {
                int nx = m.x, ny = m.y, ns = (m.spin + 1) % cur.mod;
                if ( ns != m.spin ) {
                    if ( ! field.isCollide(nx, ny, getGem(cur.num, ns) ) ) {
                        if ( _MACRO_HASH_POS(hash, n) == 0) {
                            _MACRO_CREATE_MOVING(MOV_LSPIN, 1);
                            _MACRO_HASH_POS(hash, n) = 1;
                            q.push(nm);
                        }
                    } else if ( field.wallkickTest(nx, ny, getGem(cur.num, ns), 0 ) ) {
                        if ( _MACRO_HASH_POS(hash, n) == 0 || cur.num == 2 && _MACRO_HASH_POS(hash, n) != 2 ) {
                            _MACRO_CREATE_MOVING(MOV_LSPIN, 2);
                            _MACRO_HASH_POS(hash, n) = 2;
                            q.push(nm);
                        }
                    }
                }
            }
            {
                int nx = m.x, ny = m.y, ns = (m.spin + 3) % cur.mod;
                if ( ns != m.spin ) {
                    if ( ! field.isCollide(nx, ny, getGem(cur.num, ns) ) ) {
                        if ( _MACRO_HASH_POS(hash, n) == 0) {
                            _MACRO_CREATE_MOVING(MOV_RSPIN, 1);
                            _MACRO_HASH_POS(hash, n) = 1;
                            q.push(nm);
                        }
                    } else if ( field.wallkickTest(nx, ny, getGem(cur.num, ns), 1 ) ) {
                        if ( _MACRO_HASH_POS(hash, n) == 0 || cur.num == 2 && _MACRO_HASH_POS(hash, n) != 2 ) {
                            _MACRO_CREATE_MOVING(MOV_RSPIN, 2);
                            _MACRO_HASH_POS(hash, n) = 2;
                            q.push(nm);
                        }
                    }
                }
            }
            if ( spin180Enable() && m.movs.back() != Moving::MOV_SPIN2 ) // no 180 wallkick only
            {
                int nx = m.x, ny = m.y, ns = (m.spin + 2) % cur.mod;
                if ( ns != m.spin ) {
                    if ( ! field.isCollide(nx, ny, getGem(cur.num, ns) ) ) {
                        if ( _MACRO_HASH_POS(hash, n) == 0) {
                            _MACRO_CREATE_MOVING(MOV_SPIN2, 1);
                            _MACRO_HASH_POS(hash, n) = 1;
                            q.push(nm);
                        }
                    }
                }
            }
            if ( m.movs.back() != Moving::MOV_LL && m.movs.back() != Moving::MOV_RR )
            {
                int nx = m.x, ny = m.y, ns = m.spin;
                while ( ! field.isCollide(nx - 1, ny, getGem(cur.num, ns) ) ) {
                    --nx;
                }
                if ( nx != x && _MACRO_HASH_POS(hash, n) == 0) {
                    _MACRO_CREATE_MOVING(MOV_LL, 0);
                    _MACRO_HASH_POS(hash, n) = 1;
                    q.push(nm);
                }
            }
            if ( m.movs.back() != Moving::MOV_LL && m.movs.back() != Moving::MOV_RR )
            {
                int nx = m.x, ny = m.y, ns = m.spin;
                while ( ! field.isCollide(nx + 1, ny, getGem(cur.num, ns) ) ) {
                    ++nx;
                }
                if ( nx != x && _MACRO_HASH_POS(hash, n) == 0) {
                    _MACRO_CREATE_MOVING(MOV_RR, 0);
                    _MACRO_HASH_POS(hash, n) = 1;
                    q.push(nm);
                }
            }
        }
    }
    int CalcScore(const GameField& field, int att, int clear, int depth) {
        int score = 0;
        int field_w = field.width(), field_h = field.height();
        int min_y[32] = {0};
        struct factor {
            int hole, h_change, y_factor, h_variance, att, noattclear;
        } ai_factor0 = {-50, -5, -10, -10, 100, -30}
        , ai_factor1 = {-50, -5, -10, -10, 100, -35};
        factor ai_factor = ai_factor0;
        if ( depth > 0 ) ai_factor = ai_factor1;

        // get all columns height
        for ( int x = 0; x < field_w; ++x) {
            for ( int y = 0, ey = field_h + 1; y <= ey; ++y) {
                if ( field.row[y] & ( 1 << x ) ) {
                    min_y[x] = y;
                    break;
                }
            }
        }
        min_y[field_w] = min_y[field_w-2];
        // find holes
        {
            int hole_score = 0;
            for ( int x = 0; x < field_w; ++x) {
                for ( int y = min_y[x] + 1; y <= field_h; ++y) {
                    if ( ( field.row[y] & ( 1 << x ) ) == 0) {
                        hole_score += ai_factor.hole;
                    }
                }
            }
            score += hole_score;
        }
        // height change
        {
            int last = min_y[1];
            for ( int x = 0; x <= field_w; last = min_y[x], ++x) {
                int v = min_y[x] - last;
                int absv = abs(v);
                score += absv * ai_factor.h_change;
            }
        }
        // variance
        {
            int h_variance_score = 0;
            int avg = 0;
            {
                int sum = 0;
                int sample_cnt = 0;
                for ( int x = 0; x < field_w; ++x) {
                    avg += min_y[x];
                }
                {
                    double h = field_h - (double)avg / field_w;
                    score += int(ai_factor.y_factor * h * h / field_h);
                }
                for ( int x = 0; x < field_w; ++x) {
                    int t = avg - min_y[x] * field_w;
                    if ( abs(t) > field_h * field_w / 4 ) {
                        if ( t > 0 ) t = field_h * field_w / 4;
                        else t = -(field_h * field_w / 4);
                    }
                    sum += t * t;
                    ++sample_cnt;
                }
                if ( sample_cnt > 0 ) {
                    h_variance_score = sum * ai_factor.h_variance / (sample_cnt * 100);
                }
                score += h_variance_score;
            }
        }
        // clear and attack
        if ( clear > 0 )
        {
            if ( depth > 0 ) {
                score += att * ai_factor.att * ((double)att / clear - 0.7);
            } else {
                score += att * ai_factor.att;
            }
            if ( att == 0 ) {
                score += clear * ai_factor.noattclear;
            }
        }
        return score;
    }
    int pasteClearAttack(GameField& field, int gemnum, int x, int y, int spin, signed char wallkick_spin, int &att) {
        wallkick_spin = field.WallKickValue(gemnum, x, y, spin, wallkick_spin);
        field.paste(x, y, getGem(gemnum, spin));
        int clear = field.clearLines( wallkick_spin );
        att = field.getAttack( clear, wallkick_spin );
        return clear;
    }
    Moving AISearch(const GameField& field, Gem cur, bool curCanHold, int x, int y, const std::vector<Gem>& next
        , bool canhold, int upcomeAtt, int level, int player
        , int maxdepth, int* pscore, int lastatt, int lastclear, int depth) {

        std::vector<Moving> movs;
        if ( pscore ) *pscore = SCORE_LOSE;
        GenMoving(field, movs, cur, x, y, false);
        if ( movs.empty() ) {
            Moving m;
            m.movs.push_back( Moving::MOV_NULL );
            m.movs.push_back( Moving::MOV_DROP );
            return m;
        }
        if ( maxdepth > level ) maxdepth = level;

        Moving ret;
        int maxScore = SCORE_LOSE;
        for (size_t i = 0; i < movs.size() ; ++i) {
            GameField newfield = field;
            int clear, att;
            clear = pasteClearAttack(newfield, cur.num, movs[i].x, movs[i].y, movs[i].spin, movs[i].wallkick_spin, att);
            int score = 0;
            if ( maxdepth > 0 && next.size() > 0) {
                std::vector<Gem> newnext( ++next.begin(), next.end() );
                AISearch(newfield, next[0], canhold, gem_beg_x, gem_beg_y, newnext, canhold, upcomeAtt, level, player, maxdepth - 1, &score, lastatt + att, lastclear + clear, depth + 1);
            } else {
                score += CalcScore(newfield, lastatt + att, lastclear + clear, depth);
            }
            if ( score > maxScore ) {
                maxScore = score;
                ret = movs[i];
            }
        }
        int hold_num = field.m_hold;
        if ( field.m_hold == 0 && ! next.empty()) {
            hold_num = next[0].num;
        }
        if ( canhold && curCanHold && hold_num ) {
            GenMoving(field, movs, AI::getGem(hold_num, 0), gem_beg_x, gem_beg_y, true);
            if ( ! movs.empty() ) {
                for (size_t i = 0; i < movs.size() ; ++i) {
                    GameField newfield = field;
                    int clear, att;
                    clear = pasteClearAttack(newfield, hold_num, movs[i].x, movs[i].y, movs[i].spin, movs[i].wallkick_spin, att);
                    newfield.m_hold = hold_num;
                    int score = 0;
                    if ( maxdepth > 0 && (field.m_hold != 0 && next.size() > 0 || next.size() > 1) ) {
                        if ( field.m_hold == 0 ) {
                            std::vector<Gem> newnext( ++++next.begin(), next.end() );
                            AISearch(newfield, next[1], canhold, gem_beg_x, gem_beg_y, newnext, canhold, upcomeAtt, level, player, maxdepth - 1, &score, lastatt + att, lastclear + clear, depth + 1);
                        } else {
                            std::vector<Gem> newnext( ++next.begin(), next.end() );
                            AISearch(newfield, next[0], canhold, gem_beg_x, gem_beg_y, newnext, canhold, upcomeAtt, level, player, maxdepth - 1, &score, lastatt + att, lastclear + clear, depth + 1);
                        }
                    } else {
                        score += CalcScore(newfield, lastatt + att, lastclear + clear, depth);
                    }
                    if ( score > maxScore ) {
                        maxScore = score;
                        ret = movs[i];
                    }
                }
            }
        }
        if ( ret.movs.empty() ) {
            ret.movs.push_back( Moving::MOV_NULL );
            ret.movs.push_back( Moving::MOV_DROP );
        }
        if ( pscore ) *pscore = maxScore;
        return ret;
    }
}
